base/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView

api_patterns = [
    path("public/", include("api.public.urls")),
    path("schema/", SpectacularAPIView.as_view(), name="schema"),
    path("docs/", SpectacularSwaggerView.as_view(), name="swagger-ui"),
]

urlpatterns = [
    path(f"{settings.BASE_URL}admin/", admin.site.urls),
    path(f"{settings.BASE_URL}api/", include(api_patterns)),
    path(f"{settings.BASE_URL}auth/", include("authentication.urls")),
    path(f"{settings.BASE_URL}submit/", include("submitter.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns.append(path("__debug__/", include("debug_toolbar.urls")))

submitter/urls.py
from django.contrib.auth.decorators import login_required
from django.urls import path

from .api_validation_views import (
    ValidateChebiName,
    ValidateSynonym,
    HtmxSubmitCompoundGetSources,
    GetChemicalDataFromMol,
    GetMassFromFormula,
    SpeciesSearch,
    ComponentSearch,
    GetSourceAccessionField,
)
from .views.profile import SubmitterHomeView, SubmitterProfileView
from .views.retrieve_compound import SubmitterEntityDetailView, SubmitterEntityListView
from .views.submit_compound import SubmitCompoundView
from .views.update_compound import (
    NamesUpdateView,
    HtmxUpdateCompoundGetSourceView,
    SubmitterCreateNameView,
    CompoundUpdateView,
    SubmitterCreateCrossReferenceView,
    SubmitterUpdateCrossReferenceView,
)

app_name = "submitter"

# All submitter views require login
# TODO: Can we move login_required decorator to base.urls?
urlpatterns = [
    path("", login_required(SubmitterHomeView.as_view()), name="dashboard"),
    path("new/", login_required(SubmitCompoundView.as_view()), name="submit-new"),
    path("profile/", login_required(SubmitterProfileView.as_view()), name="profile"),
    path("CHEBI:<pk>/", login_required(SubmitterEntityDetailView.as_view()), name="entity-detail"),
    path("CHEBI:<pk>/edit/", login_required(CompoundUpdateView.as_view()), name="edit-entity"),
    path("name/<pk>/update/", login_required(NamesUpdateView.as_view()), name="name-update"),
    path("CHEBI:<pk>/add-synonym/", login_required(SubmitterCreateNameView.as_view()), name="add-synonym"),
    path("CHEBI:<pk>/add-xref/", login_required(SubmitterCreateCrossReferenceView.as_view()), name="add-xref"),
    path("xref/<pk>/edit/", login_required(SubmitterUpdateCrossReferenceView.as_view()), name="update-xref"),
    path("my-submissions/", login_required(SubmitterEntityListView.as_view()), name="my-submissions"),
    # HTMX Views
    path("validate/name/", login_required(ValidateChebiName.as_view()), name="validate_chebi_name"),
    path(
        "validate/source/<str:form_type>/",
        login_required(HtmxSubmitCompoundGetSources.as_view()),
        name="validate_source",
    ),
    path("validate/synonym/", login_required(ValidateSynonym.as_view()), name="validate_synonym"),
    path(
        "validate/mol_to_chemical_data/", login_required(GetChemicalDataFromMol.as_view()), name="mol_to_chemical_data"
    ),
    path("validate/formula_to_mass/", login_required(GetMassFromFormula.as_view()), name="formula_to_mass"),
    path("validate/species/", login_required(SpeciesSearch.as_view()), name="species_search"),
    path("validate/component/", login_required(ComponentSearch.as_view()), name="component_search"),
    path(
        "validate/source_accession/",
        login_required(GetSourceAccessionField.as_view()),
        name="get_source_accession_field",
    ),
    path("htmx/get/source/", login_required(HtmxUpdateCompoundGetSourceView.as_view()), name="htmx_get_source"),
]

templates/base.html
{% load i18n static %}
<!DOCTYPE html>
<html lang=en-us">
<head>
    <title>{% block title %}ChEBI | Submission Portal{% endblock %}</title>
    <script src="{% static 'js/jquery-3.7.1.min.js' %}"></script>
    <link rel="stylesheet" href="{% static 'css/common.css' %}">
    <script src="{% static 'bootstrap/bootstrap.bundle.min.js' %}"></script>
    <link rel="stylesheet" href="{% static 'bootstrap/bootstrap.min.css' %}">
    <link rel="stylesheet" href="{% static 'bootstrap/bootstrap-icons.min.css' %}">
    {% block extrastyle %}{% endblock %}
    {% block script %}{% endblock %}
</head>
<body class="bg-body-tertiary">

<nav class="navbar navbar-expand-lg px-5 bg-dark border-bottom border-body" data-bs-theme="dark">
    <div class="container-fluid">
        <a class="navbar-brand" href="{% url 'submitter:dashboard' %}">
            <img src="{% static 'icons/logo_icon_only.svg' %}" alt="chebi_logo" width="auto" height="30"
                 class="d-inline-block align-text-top">
            Submission Portal
        </a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNavAltMarkup"
                aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
            <div class="navbar-nav ms-auto">
                <a class="nav-link" href="{% url 'submitter:dashboard' %}">Dashboard</a>
                <a class="nav-link" href="{% url 'submitter:submit-new' %}">Submit New Entry</a>
                <a class="nav-link" href="{% url 'submitter:my-submissions' %}">My Submissions</a>
                <a class="nav-link" href="{% url 'submitter:profile' %}">Profile</a>
                <form class=" nav-link d-inline" method="post" action="{% url 'logout' %}">
                    {% csrf_token %}
                    <button class="nav-link btn btn-link logout-btn" type="submit" style="padding: 0;">
                        Log out
                    </button>
                </form>
            </div>
        </div>
    </div>
</nav>

<div class="container">
    {% if messages %}
        <div class="mt-3">
            {% for message in messages %}
                <div {% if message.tags %} class="alert message-alert mb-3 alert-{{ message.tags }}"{% endif %}
                                           role="alert">{{ message|capfirst }}</div>
            {% endfor %}
        </div>
    {% endif %}

    <div class="mt-3">
        <h2 class="text-center">{% block page_heading %}{% endblock %}</h2>
        {% block content %}{% endblock %}
    </div>
</div>
</body>
</html>

<style>
    .logout-btn {
        color: unset;
        text-decoration: inherit;
        padding: inherit;
    }

    .message-alert {
        margin: auto;
        width: fit-content;
        --bs-alert-padding-y: 0.5rem;
    }
</style>